/	module name parse

	.prvd

	.globl ticks_
ticks_:
	.long	10
	.comm	oldvector_, 4
	.comm	time_out_, 256
	.comm	track_info_, 256
	.comm	current_preset_, 32
	.comm	track_enables_, 8
	.comm	song_buffer_, 4
	.comm	song_data_, 4
	.comm	song_size_, 4
	.comm	time_sig_, 2
	.comm	key_sig_, 2
	.comm	tempo_, 2
	.comm	event_, 2
	.comm	temp_, 120
	.comm	path_, 80
	.comm	name_, 20
	.comm	song_name_, 34
	.globl dur_
dur_:
	.word	0
	.word	4
	.word	0
	.word	6
	.word	8
	.word	9
	.word	12
	.word	16
	.word	18
	.word	24
	.word	32
	.word	36
	.word	48
	.word	64
	.word	72
	.word	96
	.word	128
	.word	144
	.word	192
	.word	0
	.word	288
	.comm	key_sig_tab_, 256
	.globl octave_
octave_:
	.word	0
	.word	-24
	.word	-12
	.word	0
	.word	12
	.word	24
	.comm	s_octave_, 84
	.comm	r_stack_, 160
	.comm	count_stack_, 80
	.comm	loop_pointer_, 2
	.comm	song_p_, 4
	.comm	yuck_flag_, 2
	.globl active_timer_
active_timer_:
	.word	0
	.comm	play_flag_, 2
	.comm	end_flag_, 2
	.comm	done_flag_, 2
	.globl done_handshake_
done_handshake_:
	.word	0
	.comm	midi_str_, 80
	.comm	midi_str_len_, 2
	.comm	mess_buff_, 10

	.shri

	.globl parse_
parse_:

	.bssd

	.even
L6:
	.blkb	80

	.shri

	link	a6, $-28
	movem.l	$8416, (a7)

	.shrd

	.even
L10003:
	.word	0
	.long	L30
	.word	64
	.long	L28
	.word	128
	.long	L32
	.word	192
	.long	L33
	.word	0
	.long	L28
L10007:
	.word	0
	.long	L38
	.word	64
	.long	L20002
	.word	128
	.long	L40
	.word	192
	.long	L41
	.word	0
	.long	L20002
L10010:
	.word	0
	.long	L12
	.word	128
	.long	L15
	.word	129
	.long	L16
	.word	130
	.long	L20006
	.word	131
	.long	L19
	.word	132
	.long	L20
	.word	133
	.long	L24
	.word	134
	.long	L10
	.word	255
	.long	L25
	.word	0
	.long	L26

	.shri

	move	$288, -2(a6)
	moveq	$0, d6
	movea.l	song_p_, a5
L8:
	move.b	(a5), d0
	ext	d0
	andi	$255, d0
	move	d0, d7
	movea.l	$L10010, a0
	moveq	$9, d1
	bra.s	L10011
L10012:
	addq	$4, a0
L10011:
	cmp	(a0)+, d0
	dbeq	d1,	L10012
	movea.l	(a0), a0
	jmp	(a0)
	bra.s	L8
L10:
	addq.l	$1, a5
	subq	$1, -12(a6)
	move	-12(a6), d0
	ble.s	L12
	movea.l	-10(a6), a5
L12:
	addq	$1, event_
	move	play_flag_, d0
	beq.s	L20006
	move	-2(a6), d0
	ext.l	d0
	move.l	d0, ticks_
	move	d6, d0
	ble.s	L14
	pea	L6
	subq	$1, d0
	move	d0, -(a7)
	jsr	midi_ws_
	addq	$6, a7
L14:
	move	-2(a6), -(a7)
	jsr	timing_
	addq	$2, a7
	clr	play_flag_
	move.l	a5, song_p_
	bra	L5
L20006:
	addq.l	$1, a5
	bra	L8
L15:
	addq.l	$1, a5
	addq.l	$1, a5
	move.b	(a5), d0
	ext	d0
	move	d0, key_sig_
	move	d0, -(a7)
	jsr	gen_key_tab_
	addq	$2, a7
	bra.s	L20006
L16:
	addq.l	$1, a5
	move.b	(a5), d0
	ext	d0
	andi	$255, d0
	move	d0, tempo_
	addq.l	$1, a5
	move	d0, d1
	muls	$48, d1
	ext.l	d1
	divs	$60, d1
	move	$12288, d0
	ext.l	d0
	divs	d1, d0
	move	d0, tempo_
	cmpi	$255, d0
	ble.s	L17
	clr	tempo_
L17:
	move	tempo_, d0
	move.b	d0, 16775711
	bra	L8
L19:
	addq.l	$1, a5
	move.b	(a5), d0
	ext	d0
	move	d0, time_sig_
	bra.s	L20006
L20:
	addq.l	$1, a5
	addq.l	$1, a5
	moveq	$0, d5
L23:
	cmpi	$16, d5
	bge	L20006
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_+8, a0
	adda.l	d0, a0
	move.b	(a5), d0
	ext	d0
	move	d0, (a0)
	addq	$1, d5
	bra.s	L23
L24:
	addq.l	$1, a5
	move.b	(a5)+, d0
	ext	d0
	move	d0, -12(a6)
	move.l	a5, -10(a6)
	bra	L8
L25:
	moveq	$1, d0
	move	d0, end_flag_
	clr	d0
	bra	L5
L26:
	btst	$5, d7
	beq	L27
	addq.l	$1, a5
	move.b	(a5)+, d0
	ext	d0
	move	d0, -4(a6)
	move.b	(a5)+, d0
	ext	d0
	andi	$127, d0
	move	d0, -6(a6)
	btst	$4, d7
	bne.s	L28
	move	-4(a6), d0
	andi	$192, d0
	movea.l	$L10003, a0
	moveq	$4, d1
	bra.s	L10004
L10005:
	addq	$4, a0
L10004:
	cmp	(a0)+, d0
	dbeq	d1,	L10005
	movea.l	(a0), a0
	jmp	(a0)
	bra.s	L28
L30:
	move	-6(a6), d0
	ext.l	d0
	lsl.l	$1, d0
	lea	key_sig_tab_, a0
	adda.l	d0, a0
	move	(a0), d0
	add	-6(a6), d0
	move	d0, -6(a6)
	bra.s	L28
L32:
	addq	$1, -6(a6)
	bra.s	L28
L33:
	subq	$1, -6(a6)
L28:
	move	d7, d0
	andi	$15, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_, a0
	adda.l	d0, a0
	move	(a0), -(a7)
	move	-6(a6), -(a7)
	jsr	search_
	addq	$4, a7
	move	d0, d5
	cmpi	$-1, d0
	bne.s	L35
	bra.s	L20002
L27:
	addq.l	$1, a5
	move.b	(a5)+, d0
	ext	d0
	move	d0, -4(a6)
	move.b	(a5)+, d0
	ext	d0
	move	d0, -6(a6)
	btst	$4, d7
	bne.s	L20002
	move	-4(a6), d0
	andi	$192, d0
	movea.l	$L10007, a0
	moveq	$4, d1
	bra.s	L10008
L10009:
	addq	$4, a0
L10008:
	cmp	(a0)+, d0
	dbeq	d1,	L10009
	movea.l	(a0), a0
	jmp	(a0)
	bra.s	L20002
L38:
	move	-6(a6), d0
	ext.l	d0
	lsl.l	$1, d0
	lea	key_sig_tab_, a0
	adda.l	d0, a0
	move	(a0), d0
	add	-6(a6), d0
	move	d0, -6(a6)
	bra.s	L20002
L40:
	addq	$1, -6(a6)
	bra.s	L20002
L41:
	subq	$1, -6(a6)
L20002:
	jsr	get_free_
	move	d0, d5
L35:
	move	d5, d0
	blt	L42
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+14, a0
	adda.l	d0, a0
	move	d7, d0
	andi	$15, d0
	move	d0, (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_, a2
	adda.l	d0, a2
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+14, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_, a1
	adda.l	d0, a1
	move	(a1), (a2)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+10, a2
	adda.l	d0, a2
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+14, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_+8, a1
	adda.l	d0, a1
	move	(a1), (a2)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+6, a0
	adda.l	d0, a0
	move	d7, d0
	andi	$64, d0
	move.b	d0, (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+7, a0
	adda.l	d0, a0
	move	d7, d0
	andi	$32, d0
	move.b	d0, (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+8, a0
	adda.l	d0, a0
	moveq	$1, d0
	move	d0, (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+12, a0
	adda.l	d0, a0
	move	d7, d0
	andi	$16, d0
	move	d0, (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+2, a0
	adda.l	d0, a0
	move	-4(a6), d0
	andi	$31, d0
	ext.l	d0
	lsl.l	$1, d0
	lea	dur_, a1
	adda.l	d0, a1
	move	(a1), (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+4, a0
	adda.l	d0, a0
	move	-6(a6), (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+2, a0
	adda.l	d0, a0
	move	(a0), d0
	cmp	-2(a6), d0
	bge.s	L43
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+2, a0
	adda.l	d0, a0
	move	(a0), -2(a6)
L43:
	move	-4(a6), d0
	andi	$32, d0
	beq.s	L44
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+10, a0
	adda.l	d0, a0
	addi	$40, (a0)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+10, a0
	adda.l	d0, a0
	cmpi	$127, (a0)
	ble.s	L44
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+10, a0
	adda.l	d0, a0
	moveq	$127, d0
	move	d0, (a0)
L44:
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+12, a0
	adda.l	d0, a0
	move	(a0), d0
	bne	L46
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+7, a0
	adda.l	d0, a0
	move.b	(a0), d0
	bne	L46
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+14, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_+6, a1
	adda.l	d0, a1
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$1, d0
	lea	current_preset_, a0
	adda.l	d0, a0
	move	(a0), d0
	cmp	(a1), d0
	beq	L47
	move	d6, d0
	addq	$1, d6
	movea	d0, a1
	adda.l	$L6, a1
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_, a0
	adda.l	d0, a0
	move	(a0), d0
	ori	$192, d0
	move.b	d0, (a1)
	move	d6, d0
	addq	$1, d6
	movea	d0, a1
	adda.l	$L6, a1
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+14, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_+6, a0
	adda.l	d0, a0
	move	(a0), d0
	subq	$1, d0
	move.b	d0, (a1)
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$1, d0
	lea	current_preset_, a2
	adda.l	d0, a2
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+14, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_+6, a1
	adda.l	d0, a1
	move	(a1), (a2)
L47:
	move	d6, d0
	addq	$1, d6
	movea	d0, a1
	adda.l	$L6, a1
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_, a0
	adda.l	d0, a0
	move	(a0), d0
	ori	$144, d0
	ext	d0
	ext	d0
	move.b	d0, (a1)
	move	d6, d0
	addq	$1, d6
	movea	d0, a2
	adda.l	$L6, a2
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+14, a0
	adda.l	d0, a0
	move	(a0), d0
	ext.l	d0
	lsl.l	$4, d0
	lea	track_info_+2, a1
	adda.l	d0, a1
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+4, a0
	adda.l	d0, a0
	move	(a0), d0
	ext	d0
	add	(a1), d0
	move.b	d0, (a2)
	move	d6, d0
	addq	$1, d6
	movea	d0, a1
	adda.l	$L6, a1
	move	d5, d0
	ext.l	d0
	lsl.l	$4, d0
	lea	time_out_+10, a0
	adda.l	d0, a0
	move	(a0), d0
	ext	d0
	ext	d0
	move.b	d0, (a1)
L46:
	moveq	$1, d0
	move	d0, play_flag_
	bra	L8
L42:
	moveq	$1, d0
	move	d0, yuck_flag_
	addq.l	$3, a5
	bra	L8
L5:
	movem.l	(a7), $8416
	unlk	a6
	rts
